            #GIT_CMT=a669025267e40bf0cdb24d8171ac18f114c07e77
%if %{__isa_bits} == 64
%global GOHOSTARCH amd64
%else
#TODO
%global GOHOSTARCH %{_arch}
%endif
%global GOHOSTOS %{_host_os}

%global goroot /usr/lib/golang
%global gopath /gocode
%global sdk_lib_path /pkg/%{GOHOSTOS}_%{GOHOSTARCH}/github.com/oracle
%global sdk_src_path /src/github.com/oracle/oci-go-sdk
%global preferred_3rdparty_gopath %{_datadir}

Name:           go-oci-sdk
Version:        5.10.0 
Release:    2.el7
Summary:        Go SDK for Oracle Cloud Infrastructure

License:        UPL
URL:            https://godoc.org/github.com/oracle/oci-go-sdk
Source0: go-oci-sdk-5.10.0.tar.bz2

BuildRequires:  golang
BuildRequires:  git
BuildConflicts: go-oci-sdk

%define config_sh_script %{name}-config.sh
%define config_csh_script %{name}-config.csh
%define config_script_dir /etc/profile.d

%description
This is the official Go SDK for Oracle Cloud Infrastructure

%prep

%build
cat > %{config_sh_script} <<EOF
#!/bin/bash
# This file is intended to set GOPATH for %{name}
export GOPATH=\$GOPATH:%{preferred_3rdparty_gopath}%{gopath}
EOF

cat > %{config_csh_script} <<EOF
#!/bin/tcsh
# This file is intended to set GOPATH for %{name}
set GOPATH \$GOPATH:%{preferred_3rdparty_gopath}%{gopath}
EOF

# Mock the .gopath for "go get" command
mkdir -p .gopath/src/github.com
ln -sf $PWD .gopath/src/github.com/
export GOPATH=$PWD/.gopath
go get github.com/stretchr/testify
#go get -u github.com/golang/lint/golint
go get golang.org/x/lint/golint
go get -u github.com/oracle/oci-go-sdk

pushd .gopath/src/github.com/oracle/oci-go-sdk

PATH=$GOPATH/bin:$PATH
git checkout tags/v%{version}
make build 
popd

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{config_script_dir}
install -d %{buildroot}%{goroot}%{sdk_lib_path}
install -d %{buildroot}%{preferred_3rdparty_gopath}%{gopath}%{sdk_src_path}
install -m 755 .gopath%{sdk_lib_path}/oci-go-sdk.a %{buildroot}%{goroot}%{sdk_lib_path}/oci-go-sdk.a
cp -r .gopath%{sdk_src_path}/* %{buildroot}%{preferred_3rdparty_gopath}%{gopath}%{sdk_src_path}/
chmod 755 %{buildroot}%{preferred_3rdparty_gopath}%{gopath}%{sdk_src_path}/

install -m 644 %{config_sh_script} $RPM_BUILD_ROOT%{config_script_dir}
install -m 644 %{config_csh_script} $RPM_BUILD_ROOT%{config_script_dir}

%files
%doc
%{goroot}%{sdk_lib_path}/oci-go-sdk.a
%{preferred_3rdparty_gopath}%{gopath}%{sdk_src_path}/*
%{config_script_dir}/%{config_sh_script}
%{config_script_dir}/%{config_csh_script}
%dir %{preferred_3rdparty_gopath}%{gopath}%{sdk_src_path}

# this line is to address the old mistake
# Building this RPM wiil require removing go-oci-sdk if installed
# The reason is to remove %{preferred_3rdparty_gopath}%{gopath}%{sdk_src_path}
# But old RPMs did not own the directory, so it should be done in the update phase
%dir %{preferred_3rdparty_gopath}%{gopath}%{sdk_src_path}

%changelog
* Fri Jun 14 2019 Kyoungwon Stephen Kim <stephen.kim@oracle.com> - 5.10.0-2.el7
- changed the source installation location to /usr/share/gocode, which seems
  preferred 3rd party go package location Thus, added the two scirpts to
  /etc/profile.d, for GOPATH (Kyoungwon Stephen Kim)

* Fri Jun 14 2019 Kyoungwon Stephen Kim <stephen.kim@oracle.com> - 5.10.0-1.el7
- imported from v5.10 in the upstream

* Fri May 24 2019 Stephen Kyoungwon Kim <stephen.kim@oracle.com> - 5.10.0-1
- Import 5.10.0

* Fri May 24 2019 Stephen Kyoungwon Kim <stephen.kim@oracle.com> - 5.4.0-3
- Include /usr/lib/golang/src/github.com/oracle/oci-go-sdk directory in the package
- Oracle-Bug: 29909474

* Fri May 24 2019 Stephen Kyoungwon Kim <stephen.kim@oracle.com> - 5.4.0-2
- updated to keep Lans' changes made in 4.0.0-3

* Fri May 24 2019 Tianyue Lan <tianyue.lan@oracle.com> - 5.4.0-1
- import v5.4.0 as of May 21 2019
- Stephen <stephen.kim@oracle.com> cherry-picked from Tianyue's original commit

* Tue May 21 2019 Lans Hung <lans.hung@oracle.com> 4.0.0-3
- Fix spec file to build for specific version only.
- Change install location to /usr/lib instead of /usr/lib64
- Fix error when downloading dependency from upstream during build step. 
  Use go get golang.org/x/lint/golint instead of go get -u github.com/golang/lint/golint

* Tue Mar 05 2019 Lans Hung <lans.hung@oracle.com> - 4.0.0-1
- Initialize package.

